#include <linux/dmaengine.h>
#include <linux/crc16.h>
#define XGENE_DMA_MAX_LEN	0x400000 
struct dma_addr_map
{
	void *virt;
	dma_addr_t phys;
	int len;
};

struct xgene_dma_completion {
	wait_queue_head_t cmpl;
	atomic_t flag;
	struct scatterlist *sgl;
	struct dma_slave_config *slave;
	struct dma_device *device;
	int sg_cnt;
};

struct xgene_pcie_ep_dma
{
	u64 base;
	u32 len;
	u32 cmd;
	u32 status;
	u32 crc;
};

static inline u16 xgene_mem_crc(struct dma_addr_map *map)
{
	int i;
	u16 crc = 0;
	for (i = 0; map[i].len; i++) {
		crc = crc16(crc, map[i].virt, map[i].len);
	}
	pr_info ("CRC = %X\n",crc);
	return crc;
}

int xgene_pcie_dma_memcpy(struct dma_chan *chan, u64 dest, u64 src,
		size_t len, enum dma_transfer_direction dir);
struct dma_addr_map *xgene_pcie_dma_sg_write(struct dma_chan *chan,
		dma_addr_t dst, int rand);
struct dma_addr_map *xgene_pcie_dma_sg_read(struct dma_chan *chan,
		dma_addr_t src, int rand);
struct dma_chan *xgene_pcie_dma_request_channel (int chan);
struct dma_addr_map *xgene_pcie_dma_alloc_mem(struct device *dev, int rand,
		enum dma_transfer_direction dir, dma_addr_t ep_addr);
